<mat-card [ngClass]="{'post-with-comments': showComments}">
  <mat-card-header>
    <img mat-card-avatar src="{{post.author.avatar}}" alt="Avatar">
    <mat-card-title>{{post.author.userName}}</mat-card-title>
    <div class="date">{{post.createdAt | date:'d/M/yy, h:mm a'}}</div>
  </mat-card-header>
  <img mat-card-image *ngIf="post.previewImage" mat-card-image src="{{post.previewImage}}" alt="Photo">
  <mat-card-content>
    <p>{{post.body}}</p>
  </mat-card-content>
  <mat-card-actions class="actions-buttons" align="end">
    <button mat-icon-button color="primary" (click)="toggleEditContainer()" disabled="{{isAuthorOfPost()}}">
      <mat-icon aria-label="Edit">edit</mat-icon>
    </button>
    <button mat-icon-button color="basic" (click)="deletePost()" disabled="{{isAuthorOfPost()}}">
      <mat-icon aria-label="Delete">delete</mat-icon>
    </button>
    <button mat-icon-button color="basic" (click)="dislikePost()">
      <mat-icon matBadge="{{countDislikes()}}" matBadgeColor="accent" matBadgeSize="medium"
        [matBadgeHidden]="countDislikes() === 0" aria-label="Dislike">thumb_down</mat-icon>
    </button>
    <button mat-icon-button color="primary" (click)="likePost()">
      <mat-icon matBadge="{{countLikes()}}" matBadgeColor="accent" matBadgeSize="medium"
        [matBadgeHidden]="countLikes() === 0" aria-label="Like">favorite</mat-icon>
    </button>
    <button mat-icon-button color="primary" (click)=" toggleReactions()">
      <mat-icon aria-label="Show Likes">toc</mat-icon>
    </button>
    <button mat-icon-button color="accent">
      <mat-icon aria-label="Share">share</mat-icon>
    </button>
    <button mat-icon-button color="basic" (click)=" toggleComments()">
      <mat-icon matBadge="{{post.comments.length}}" matBadgeColor="warn" matBadgeSize="medium"
        [matBadgeHidden]="post.comments.length === 0" aria-label="Add comment">comment</mat-icon>
    </button>
  </mat-card-actions>
  <mat-card class="post-create-container" *ngIf="currentUser && showEditContainer">
    <div *ngIf="loading" class="mat-spinner-wrapper">
      <mat-spinner></mat-spinner>
    </div>
    <mat-card-content>
      <mat-form-field>
        <textarea [(ngModel)]="post.body" matInput placeholder="Write something..."></textarea>
      </mat-form-field>
      <div class="image-container">
        <mat-icon aria-label="Send" (click)="removeImage()">close</mat-icon>
        <img mat-card-image class="post-image" *ngIf="imageUrl" mat-card-image src="{{imageUrl}}" alt="Photo">
      </div>
    </mat-card-content>
    <mat-card-actions align="end">
      <input hidden #file accept="image/*" type="file" (change)="loadImage($event.target)">
      <button mat-icon-button color="accent" (click)="file.click()">
        <mat-icon aria-label="Choose an image">image</mat-icon>
      </button>
      <button mat-icon-button color="primary" matTooltip="Post it" (click)="editPost()">
        <mat-icon aria-label="Edit">send</mat-icon>
      </button>
    </mat-card-actions>
  </mat-card>
  <div *ngIf="showReactions">
    <app-reaction *ngFor="let _reaction of post.reactions" [reaction]="_reaction" [currentUser]="currentUser">
    </app-reaction>
  </div>
  <div *ngIf="showComments">
    <mat-divider></mat-divider>
    <div class="new-comment">
      <mat-form-field>
        <textarea [(ngModel)]="newComment.body" matInput placeholder="Comment it..."></textarea>
      </mat-form-field>
      <button mat-icon-button color="primary" matTooltip="Send" (click)="sendComment()">
        <mat-icon aria-label="Send">send</mat-icon>
      </button>
    </div>
    <div *ngIf="post.comments.length > 0" class="comments-count">
      Just {{post.comments.length}} in all
    </div>
    <app-comment *ngFor="let _comment of post.comments" [comment]="_comment" [currentUser]="currentUser"></app-comment>
  </div>
</mat-card>